/*
 March 2020
 coins.cpp
 
 Наков, 501 стр. (537)
 
 Сума на монети
 Дадени са $n$ типа монети със стойности съответно: $c_0, c_1, ..., c_{n–1}$, и естествено число $s$. Да се намери броят на различните представяния на $s$ с монети измежду наличните типове. Стойностите $c_0, c_1, ..., c_{n–1$ са цели положителни числа. Всеки тип монети може да участва в сумата неограничен брой пъти.
 
 Вход
 Всеки тестов пример е зададен на два реда на стандартния вход. Първият ред съдържа стойностите на монетите, а втория - сумите, които трябва да се формират от зададените стойности на монетите. Входът съдържа много примери.
 
 Ограничения
 $1 \le s \le 100$,
 $1 \le n \le 100$
 
 Изход
 За всеки пример на отделен ред на стандартния изход се отпечатва броят на различните представяния за всяка сума.
 
 \smallskip
 Примерен вход:
 \begin{verbatim}
 1 2 3 4 6
 6 5 4 3 2 1
 \end{verbatim}
 
 \smallskip
 Изход за примерния вход:
 \begin{verbatim}
10 6 5 3 2 1
 \end{verbatim}

*/
// coin_min.c
//#include <stdio.h>
#include <iostream>
#include <string>
#include<sstream>

#define MAXCOINS  100
#define MAXSUM    100

using namespace std;

unsigned long F[MAXSUM][MAXSUM];
unsigned char exist[MAXSUM];

unsigned coins[MAXCOINS] = {1,2,3,4,6};
unsigned sum = 6;
unsigned n = 5;

void init()
{
    unsigned i, j;
   
    for (i = 0; i <= sum; i++)
        for (j = 0; j <= sum; j++) F[i][j] = 0;
   
    for (i = 0; i <= sum; i++) exist[i] = 0;
    for (i = 0; i < n; i++) exist[coins[i]] = 1;
}

unsigned long count(unsigned sum, unsigned max)
{
    unsigned long i;
    if (sum <= 0)
        return 0;
    if (F[sum][max] > 0) return F[sum][max];
    else {
        if (sum < max) max = sum;
        if (sum == max && exist[sum]) F[sum][max] = 1;
        for (i = max; i > 0; i--)
            if (exist[i])
                F[sum][max] += count(sum - i, i);
    }
    return F[sum][max];
}

int main()
{
    string s;
    while(getline(cin, s))
    {
        istringstream is(s);
        n = 0;
        while(is >> coins[n]) n++;
        getline(cin, s);
        istringstream iss(s);
        while(iss >> sum)
        {
            init();
            cout << count(sum, sum) << " ";
        }
        cout << endl;
    }
    return 0;
}
