/*
 March 2020
 poly.cpp
 
Полином
 Да се намери най-малката и най-голямата стойност на полинома $p_n(x) = a_0 + a_1x + a_2x^2 + ... + a_nx^n$  в интервала $[a, b]$ за цели стойности на аргумента.
 
 Вход
 За всеки пример на стандартния вход на един ред са дадени числата $a, b, a_1, a_2, ..., a_n$.
 
 Ограничения
 Числата от входа са цели и в интервала [1, $10^6$].
 $2 \le n \le 10$
 
 Изход
 За всеки пример на отделен ред на стандартния изход се изведат двете търсени числа.
 
 \smallskip
 Примерен вход:
 \begin{verbatim}
 0 10 3 2 1
 -10 5 12 -2 3 -4 1
 \end{verbatim}
 
 \smallskip
 Изход за примерния вход:
 \begin{verbatim}
 3 123
 4 14332
 \end{verbatim}

*/
//
#include <iostream>
#include <string>
#include <sstream>
using namespace std;

typedef long long ll;
int a, b, n, ai[100];;

ll calc(int x)
{
    ll val = ai[n-1];
    for (int i = n - 2; i >= 0; i--)
        val = ai[i] + x*val;
    return val;
}

int main()
{
    string s;
    while(getline(cin, s))
    {
        istringstream is(s);
        is >> a >> b;
        n = 0;
        while(is >> ai[n]) n++;
 //       for(int i = 0; i < n; i++) cout << ai[i] << " ";
 //       cout << endl;
        ll maxx = calc(a);
        ll minn = maxx;
        for(int i = a + 1; i <= b; i++)
        {
            ll val = calc(i);
            if(val > maxx) maxx = val;
            if(val < minn) minn = val;
        }
        cout << minn << " " << maxx << endl;
    }
    return 0;
}
