/*
 March 2020
 taxi.cpp
 
 Наков, 8.4.1, стр. 516
 
 Такси
 Движението на "Е-такси" по много дълга улица е организирано така, че да има спирка на всеки километър. "Е-такси" се движи по улицата от всяка спирка и изминава 1, 2, ..., 10 километра без спиране. Цената за $i$ км е $c_i, i = 1, 2, ..., 10$.
 Например:
 $c_1 = 12, c_2 = 21, c_3 = 31, c_4 = 40, c_5 = 49, c_6 = 58, c_7 = 69, c_8 = 79, c_9 = 90, c_{10} = 101$.
 
 Пътник иска да пътува $n$ километра. Какви разстояния на пътуване трябва да избере, така, че пътуването да му излезе най-евтино, и каква е цената на цялото пътуване?

 Вход
 За един тестов пример от стандартния вход се чете един ред, на който са записани 10 числа -- цените за разстояния 1, 2, ..., 10 км и още едно число на същия ред - числото $n$.
 
 Ограничения
Всички числа от входа са положителни и по-малки от 1000.
 
 Изход
 За всеки пример на стандартния изход се отпечатава едно число на отделен ред -- цената на цялото пътуване.
 
 \smallskip
 Примерен вход:
 \begin{verbatim}
 12 21 31 40 49 58 69 79 90 101 15
 \end{verbatim}
 
 \smallskip
 Изход за примерния вход:
 \begin{verbatim}
 147
 \end{verbatim}
*/

#include <iostream>
#include <string>
#include <sstream>
#define MAXN    1000
#define MAXK    20
#define INFINITY 1000000

using namespace std;

struct {
    unsigned last;
    unsigned value;
} dist[MAXN];

unsigned values[MAXK+1] = {0,12,21,31,40,49,58,69,79,90,101};
unsigned n = 15;
unsigned k = 10;

void solve(unsigned n)
{ unsigned i, j;
    dist[0].value = 0;
    for (i = 1; i <= n; i++) {
        dist[i].value = INFINITY;
        for (j = 1; j <= k && j <= i; j++)
            if (dist[i - j].value + values[j] < dist[i].value) {
                dist[i].value = dist[i - j].value + values[j];
                dist[i].last = j;
            }
    }
}
/*
void print(unsigned n)
{ printf("\n%s%u", "", dist[n].value);
    printf("\n");
    while (n > 0) {
        printf("\n%u %u", dist[n].last, values[dist[n].last]);
        n -= dist[n].last;
    }
}
*/
int main()
{
/*
    solve(n);
    cout << dist[n].value << endl;
    return 0;
 */
    string s;
    while(getline(cin, s))
    {
        istringstream is(s);
        values[0] = 0;
        for(int i = 1; i <= 10; i++) is >> values[i];
        is >> n;
//        for (int i = 0; i <= 10; i++) cout << values[i] << " ";
//        cout << endl << "k =" << k << " n=" << n << endl;
        solve(n);
        cout << dist[n].value << endl;
/*
        while (n > 0) {
            cout << dist[n].last << " " << values[dist[n].last] << endl;
            n -= dist[n].last;
        }
*/
    }
    return 0;
}
