/*
  March 2020
    h.cpp

 Последователни гласни.
 Намерете броя на низовете, съставени от малки латински букви с N символа, такива, че не съдържат повече от K последователни гласни. Гласни са латинските букви ‘a’, ‘e’, ‘o’, ‘u’, ‘i’, ‘y’.
 
 Input Format
 На първия ред на стандартния вход е зададен броят тестове T. Всеки от следващите T реда съдържа по две цели числа N и K - съответно дължината на низа, който трябва да се състави, и колко най-много последователни гласни може да има в него.
 
 Constraints
 1 <= N, K <= 1000
 
 Output Format
 За всеки тест на отделен ред изведете по едно цяло число - броя възможни низове. Тъй като това число може да е много голямо, го изведете по модул 1000000009.
 
 Sample Input 0
 3
 3 1
 5 2
 666 42
 
 Sample Output 0
 15920
 11510720
 8865198
*/

#define MAX 1024
#define MOD 1000000009

#include <cstdio>
#include <cstring>

int n, k;
int dyn[MAX][MAX];

int recurse(int idx, int rem)
{
    if (idx >= n) return 1;
    if (dyn[idx][rem] != -1) return dyn[idx][rem];
    
    int ans = (recurse(idx + 1, k) * 20LL) % MOD;
    if (rem > 0) ans = (recurse(idx + 1, rem - 1) * 6LL + ans) % MOD;
    
    return dyn[idx][rem] = ans;
}

int main()
{
    FILE* in = stdin; FILE* out = stdout;
    //    in = fopen("DesignPatterns.in", "rt"); out = fopen("DesignPatterns.out", "wt");
    
    int numTests;
    fscanf(in, "%d", &numTests);
    
    for (int test = 0; test < numTests; test++)
    {
        fscanf(in, "%d %d", &n, &k);
        memset(dyn, -1, sizeof(dyn));
        fprintf(out, "%d\n", recurse(0, k));
    }
    return 0;
}

// второ решение
#include <bits/stdc++.h>
#define D(x) cout << "at " << __LINE__ << " " << #x << "=" << (x) << endl;
#define f1(i, s, e) for(int i = s; i < e; i++)
#define f(i, n) for(int i = 0; i < n; i++)
#define fr(i, n) for(int i = n-1; i >= 0; i--)
#define fr2(i, s, e) for(int i = s; i >= e; i--)
#define L(x) cout << __LINE__ << ":" << x << endl;
using ll = long long;
using namespace std;

void read (int arr[], int n) {
    f(i, n) cin >> arr[i];
}

void read (int** arr, int n, int m) {
    f(i, n) f(j, m) cin >> arr[i][j];
}

void print(int arr[], int n) {
    f(i, n) cout << arr[i] << " ";
    cout << endl;
}

const int maxn = 1005;
ll mod = 1000000009;
ll arr[maxn][maxn];


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    
    int t;
    cin >> t;
    while(t-- > 0) {
        int n, k;
        cin >> n >> k;
        f(i, n+1) f(j, k+1) {
            if(i == 0 && j == 0) {
                arr[i][j] = 1;
            } else if(i==0) arr[i][j] = 0;
            else {
                if(j!=0) {
                    arr[i][j] = 6 * arr[i-1][j-1];
                    arr[i][j] %= mod;
                } else {
                    arr[i][j] = 0;
                    f(l, k+1) {
                        arr[i][j] += 20 * arr[i-1][l];
                        arr[i][j] %= mod;
                    }
                }
            }
        }
        ll sum = 0;
        f(i, k+1) {
            sum += arr[n][i];
            sum %= mod;
        }
        cout << sum << endl;
        // f(i, n+1) print(arr[i], k+1);
    }
}
